unit CustomVst;

interface

uses
  System.Generics.Collections, System.SysUtils,
  Data.DB,
  FireDAC.Comp.Client, FireDAC.Stan.Param, FireDAC.Comp.DataSet, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.Async, FireDAC.DApt,
  AdvCombo, AdvPanel;

type
   TCustomVst = class
   strict protected
    FcbxReport: TAdvComboBox;
    FcbxText: TAdvComboBox;
    FlstQryField: TObjectList<TField>;
    FOldPKey: Integer;
    FPkey: Integer;
    FqryReport: TFDQuery;
    FqryText: TFDQuery;
    FTable: TFDTable;
    procedure ClearAndFreeComboBoxObj(ComboBox: TAdvComboBox); overload;
   public
    constructor Create(const AParentPanel, AEditPanel: TAdvPanel; const ADataSource: TDataSource); virtual;
    destructor Destroy; override;
    property Pkey: Integer read FPkey write FPkey;
  end;

implementation

uses
  FDFunction;

constructor TCustomVst.Create;
begin
  FqryReport := TFDFunction.NewQry(nil);
  FqryReport.SQL.Text :=
  'SELECT R.IDREPORTS, R.LOCALNAME'+
  ' FROM REPORTS R'+
  ' ORDER BY R.LOCALNAME';

  FqryText := TFDFunction.NewQry(nil);
  FlstQryField := TObjectList<TField>.Create(False);
end;

destructor TCustomVst.Destroy;
begin
  FreeAndNil(FqryReport);
  FreeAndNil(FqryText);
  FreeAndNil(FlstQryField);
  inherited;
end;

{ TCustomVst }

procedure TCustomVst.ClearAndFreeComboBoxObj(ComboBox: TAdvComboBox);
var
  I: Integer;
begin
  ComboBox.Items.BeginUpdate;

  try
    for I := ComboBox.Items.Count - 1 downto 0 do
    begin
      ComboBox.Items.Objects[I].Free;
      ComboBox.Items.Objects[I] := nil;
    end;
  finally
    ComboBox.Items.Clear;
    ComboBox.Items.EndUpdate;
  end;
end;

end.
