unit VstTableData;

interface

uses
  System.Generics.Collections, System.SysUtils,
  CustomVst, DeclarationTypes;

type
  TFKey = class
  strict private
    FIDReport: Integer;
    FIDSection: Integer;
  public
    property IDReport: Integer read FIDReport write FIDReport;
    property IDSection: Integer read FIDSection write FIDSection;
  end;

  TVstTableData = class(TCustomVst)
  public
    procedure FillcbxReport; virtual;
    procedure FillcbxText; virtual;
    function GetRecord: Boolean;
  end;

implementation

uses
  FDFunction;

{ TVstTableData }

procedure TVstTableData.FillcbxReport;
var
  FInt: TInteger;
begin
  ClearAndFreeComboBoxObj(FcbxText);
  TFDFunction.QryOpen(FqryReport, FlstQryField);
  FqryReport.First;

  while not FqryReport.Eof do
  begin
    FInt := TInteger.Create(FqryReport.Fields.Fields[0].AsInteger);
    FcbxReport.Items.AddObject(FqryReport.Fields.Fields[1].AsString, FInt);
    FqryReport.Next;
  end;

  FcbxReport.ItemIndex := 0;
  FcbxReport.OnChange(FcbxReport);
end;

procedure TVstTableData.FillcbxText;
var
  FKey: TFKey;
begin
  ClearAndFreeComboBoxObj(FcbxText);
  TFDFunction.QryOpen(FqryText, FlstQryField);
  FqryText.First;

  while not FqryText.Eof do
  begin
    FKey := TFKey.Create;
    FKey.IDReport := FqryText.Fields.Fields[0].AsInteger;
    FKey.IDSection := FqryText.Fields.Fields[1].AsInteger;
    FcbxText.Items.AddObject(FqryText.Fields.Fields[2].AsString, FKey);
    FqryText.Next;
  end;

  FcbxText.ItemIndex := 0;
  FcbxText.OnChange(FcbxText);
end;

function TVstTableData.GetRecord: Boolean;
begin
  Result := False;

  if FPkey = 0 then
    Exit;


  if (FPkey <> 0) and (FOldPKey <> FPkey) then
  begin
    if FTable.Locate(FTable.Fields.Fields[0].FieldName, FPkey, []) then
    begin
      FOldPKey := FPkey;
      Result := True;
    end
    else
      FOldPKey := 0;
  end;
end;

end.
