unit prnReportText;

interface

uses
  System.SysUtils, System.Variants, System.Classes, System.Generics.Collections,
  Data.DB,
  Vcl.Controls, Vcl.Forms, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.PlatformDefaultStyleActnCtrls,
  DBAdvRichEditorRTFIO, FireDAC.Comp.Client, FireDAC.Stan.Param, FireDAC.Comp.DataSet, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.Async,
  FireDAC.DApt, Advcombo, advofficepager, AdvSplitter, AdvRichEditorToolBar, AdvScrollControl, AdvRichEditor,
  AdvToolBar, advglowbutton, advstyleif, advappstyler, AdvRichEditorIO, AdvRichEditorBase, AdvToolBarExt, advpanel,
  dmBasic, jstVirtualStringTree, DeclarationTypes, VstTableData;

type
  TRptText = class(TVstTableData)
  strict private
    FIdFoc: Integer;
    FIDReports: Integer;
    procedure CreateObjectSQL;
  public
    constructor Create(const AParentPanel, AEditPanel: TAdvPanel; const ADataSource: TDataSource); override;
    procedure FillcbxText; override;
    property IdFoc: Integer read FIdFoc write FIdFoc;
    property IDReports: Integer write FIDReports;
  end;

  TRptDefaultText = class(TVstTableData)
  strict private
    FIDReports: Integer;
    procedure CreateObjectSQL;
  public
    constructor Create(const AParentPanel, AEditPanel: TAdvPanel; const ADataSource: TDataSource); override;
    procedure FillcbxText; override;
    property IDReports: Integer write FIDReports;
  end;

  TfrmprnReportText = class(TForm)
    adrchcbClipboard: TAdvRichEditorClipboardRibbonToolBar;
    adrchcbClipboardDefault: TAdvRichEditorClipboardRibbonToolBar;
    adrchedEdit: TAdvRichEditorEditingRibbonToolBar;
    adrchedEditDefault: TAdvRichEditorEditingRibbonToolBar;
    adrchfnFont: TAdvRichEditorFontRibbonToolBar;
    adrchfnFontDefault: TAdvRichEditorFontRibbonToolBar;
    adrchprParagraph: TAdvRichEditorParagraphRibbonToolBar;
    adrchprParagraphDefault: TAdvRichEditorParagraphRibbonToolBar;
    adtbpgRichtEditor: TAdvToolBarPager;
    adtbpgRichtEditorDefault: TAdvToolBarPager;
    advcbxFoc: TAdvComboBox;
    advcbxReport: TAdvComboBox;
    advcbxReportDef: TAdvComboBox;
    advpgeRichtEditorHome: TAdvPage;
    advpgeRichtEditorHomeDefault: TAdvPage;
    advpgeRichtEditorInsert: TAdvPage;
    advpgeRichtEditorInsertDefault: TAdvPage;
    advpgeRptDef: TAdvOfficePage;
    advpgeRptText: TAdvOfficePage;
    advredDefaultReportText: TAdvRichEditor;
    advredReportText: TAdvRichEditor;
    advsplRptDef: TAdvSplitter;
    advsplRptText: TAdvSplitter;
    advtlbrItems: TAdvToolBar;
    advtlbrItemsDefault: TAdvToolBar;
    blbfldReportTextsCONTENT: TBlobField;
    blbfldReportTextsDefaultCONTENT: TBlobField;
    dbrdtfDefaultReportText_01: TDBAdvRichEditorRTFIO;
    dbrdtfReportText_02: TDBAdvRichEditorRTFIO;
    dsReportTexts: TDataSource;
    dsReportTextsDefault: TDataSource;
    fdtblReportTexts: TFDTable;
    fdtblReportTextsDefault: TFDTable;
    frmstlrprnReportText: TAdvFormStyler;
    glwbtnImage: TAdvGlowButton;
    glwbtnImageDefault: TAdvGlowButton;
    glwbtnLink: TAdvGlowButton;
    glwbtnLinkDefault: TAdvGlowButton;
    intgrfldReportTextsDefaultFKREPORTS: TIntegerField;
    intgrfldReportTextsDefaultIDREPORTTEXTSDEFAULT: TIntegerField;
    intgrfldReportTextsDefaultSECTIONID: TIntegerField;
    intgrfldReportTextsFKFOCS: TIntegerField;
    intgrfldReportTextsFKREPORTS: TIntegerField;
    intgrfldReportTextsIDREPORTTEXTS: TIntegerField;
    intgrfldReportTextsSECTIONID: TIntegerField;
    jstpnlFocTop: TAdvPanel;
    jstpnlListOfRpt: TAdvPanel;
    jstpnlListOfRptDef: TAdvPanel;
    jstpnlRichtEditor: TAdvPanel;
    jstpnlRichtEditorDefault: TAdvPanel;
    jstpnlRptDefBasic: TAdvPanel;
    jstpnlRptDefEdit: TAdvPanel;
    jstpnlRptDefEditBasic: TAdvPanel;
    jstpnlRptTextBasic: TAdvPanel;
    jstpnlRptTextEdit: TAdvPanel;
    jstpnlRptTextEditBasic: TAdvPanel;
    jstpnlVstRptDef: TAdvPanel;
    jstpnlVstRptText: TAdvPanel;
    offpgrRptText: TAdvOfficePager;
    strngfldReportTextsDefaultSECTIONNAME: TStringField;
    strngfldReportTextsSECTIONNAME: TStringField;
    advcbxText: TAdvComboBox;
    advcbxTexDefault: TAdvComboBox;
    procedure FormCreate(Sender: TObject);
    procedure advcbxFocChange(Sender: TObject);
    procedure advcbxReportChange(Sender: TObject);
    procedure advcbxReportDefChange(Sender: TObject);
    procedure advcbxTexDefaultChange(Sender: TObject);
    procedure advcbxTextChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure offpgrRptTextChange(Sender: TObject);
  strict private
  const
    SectionName = 0;
  var
    FDQueryRpt: TFDQuery;
    FoRptDefaultText: TRptDefaultText;
    FoRptText: TRptText;
    FActualObject: TObject;
    procedure FillcbxFoc;
  protected
    procedure CreateObjects;
    procedure SetForm;
  end;

var
  frmprnReportText: TfrmprnReportText;

implementation

uses
  FDFunction;


{$R *.dfm}

procedure TfrmprnReportText.FormCreate(Sender: TObject);
begin
  SetForm;
end;

{ TfrmReportText }

procedure TfrmprnReportText.advcbxFocChange(Sender: TObject);
var
  FInt: TInteger;
begin
  FInt := TInteger(advcbxFoc.Items.Objects[advcbxFoc.ItemIndex]);
  FoRptText.IdFoc := FInt.Value;
  FoRptText.FillcbxReport;
end;

procedure TfrmprnReportText.advcbxReportChange(Sender: TObject);
var
  CombBox: TAdvComboBox;
  FInt: TInteger;
begin
  if not Assigned(FoRptText) then
    Exit;

  CombBox := TAdvComboBox(Sender);

  if CombBox.Items.Count = 0 then
    Exit;

  FInt := TInteger(CombBox.Items.Objects[CombBox.ItemIndex]);
  FoRptText.IDReports := FInt.Value;
  FoRptText.FillcbxText;
end;

procedure TfrmprnReportText.advcbxReportDefChange(Sender: TObject);
var
  CombBox: TAdvComboBox;
  FInt: TInteger;
begin
  if not Assigned(FoRptDefaultText) then
    Exit;

  CombBox := TAdvComboBox(Sender);

  if CombBox.Items.Count = 0 then
    Exit;

  FInt := TInteger(CombBox.Items.Objects[CombBox.ItemIndex]);
  FoRptDefaultText.IDReports := FInt.Value;
  FoRptDefaultText.FillcbxText;
end;

procedure TfrmprnReportText.advcbxTexDefaultChange(Sender: TObject);
var
  CombBox: TAdvComboBox;
  FKey: TFKey;
begin
  CombBox := TAdvComboBox(Sender);
  FKey := TFKey(CombBox.Items.Objects[CombBox.ItemIndex]);
  FoRptDefaultText.Pkey := FKey.IDReport;
  FoRptDefaultText.GetRecord;
end;

procedure TfrmprnReportText.advcbxTextChange(Sender: TObject);
var
  CombBox: TAdvComboBox;
  FKey: TFKey;
begin
  CombBox := TAdvComboBox(Sender);
  FKey := TFKey(CombBox.Items.Objects[CombBox.ItemIndex]);
  FoRptText.Pkey := FKey.IDReport;
  FoRptText.GetRecord;
end;

procedure TfrmprnReportText.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmprnReportText.FormDestroy(Sender: TObject);
begin
  TFDFunction.FreeAndNilQry(FDQueryRpt, nil);
  FreeAndNil(FoRptText);
  FreeAndNil(FoRptDefaultText);
end;

procedure TfrmprnReportText.offpgrRptTextChange(Sender: TObject);
begin
  if offpgrRptText.ActivePageIndex = -1 then
    offpgrRptText.ActivePageIndex := 0;

  case offpgrRptText.ActivePageIndex of
    0: FActualObject := FoRptText;
    1: FActualObject := FoRptDefaultText;
  end;
end;

procedure TfrmprnReportText.FillcbxFoc;
var
  FInt: TInteger;
begin
  FInt := TInteger.Create(1440);
  advcbxFoc.Items.AddObject('1. SVB', FInt);
  FInt := TInteger.Create(1719);
  advcbxFoc.Items.AddObject('2. SVB', FInt);
  advcbxFoc.ItemIndex := 0;
end;

procedure TfrmprnReportText.CreateObjects;
begin
  FoRptText:= TRptText.Create(jstpnlRptTextBasic, jstpnlRptTextEdit, dsReportTexts);
  FoRptDefaultText:= TRptDefaultText.Create(jstpnlRptDefBasic, jstpnlRptDefEdit, dsReportTextsDefault);
end;

procedure TfrmprnReportText.SetForm;
begin
  frmprnReportText := Self;
  fdtblReportTextsDefault.Active := True;
  fdtblReportTexts.Active := True;
  CreateObjects;
  FillcbxFoc;
  advcbxFoc.OnChange(advcbxFoc);
  advcbxReportDef.OnChange(advcbxReportDef);
end;

{ TRptText }

constructor TRptText.Create(const AParentPanel, AEditPanel: TAdvPanel; const ADataSource: TDataSource);
begin
  FTable := frmprnReportText.fdtblReportTexts;
  inherited;
  CreateObjectSQL;
  FcbxReport := frmprnReportText.advcbxReport;
  FcbxText := frmprnReportText.advcbxText;
end;

procedure TRptText.CreateObjectSQL;
begin
  inherited;
  FqryText.SQL.Text :=
  'SELECT R.IDREPORTTEXTS, R.SECTIONID, R.SECTIONNAME'+
  ' FROM REPORTTEXTS R'+
  ' WHERE R.FKREPORTS = :FKREPORTS AND R.FKFOCS = :FKFOCS'+
  ' ORDER BY R.SECTIONID';
end;

procedure TRptText.FillcbxText;
begin
  FqryText.ParamByName('FKREPORTS').AsInteger := FIDReports;
  FqryText.ParamByName('FKFOCS').AsInteger := FIdFoc;
  inherited;
end;

{ TRptDefaultText }

constructor TRptDefaultText.Create(const AParentPanel, AEditPanel: TAdvPanel; const ADataSource: TDataSource);
begin
  FTable := frmprnReportText.fdtblReportTextsDefault;
  inherited;
  CreateObjectSQL;
  FcbxReport := frmprnReportText.advcbxReportDef;
  FcbxText := frmprnReportText.advcbxTexDefault;
  FillcbxReport;
end;

procedure TRptDefaultText.CreateObjectSQL;
begin
  inherited;
  FqryText.SQL.Text :=
  'SELECT R.IDREPORTTEXTSDEFAULT, R.SECTIONID, R.SECTIONNAME'+
  ' FROM REPORTTEXTSDEFAULT R'+
  ' WHERE R.FKREPORTS = :FKREPORTS'+
  ' ORDER BY R.SECTIONID';
end;

procedure TRptDefaultText.FillcbxText;
begin
  FqryText.ParamByName('FKREPORTS').AsInteger := FIDReports;
  inherited;
end;

end.
